#    Kye - classic puzzle game
#    Copyright (C) 2005, 2006 Colin Phipps <cph@moria.org.uk>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import pygtk
pygtk.require('2.0')
import gtk
from kye.game import KGame
from kye.canvas import KCanvas
import pango

class StatusBar(gtk.DrawingArea):
    def __init__(self, kyeimg):
	gtk.DrawingArea.__init__(self)
	self.set_size_request(480,20)
	self.__kyeimg = kyeimg
	self.connect("expose-event",self.expose)
	self.kyes = None
	self.hint = None
	self.levelnum = None
	self.diamonds = None
	self.pgctx = self.create_pango_context()

    def expose(self,window,event):
	gc = self.window.new_gc()
	gc.set_fill(gtk.gdk.SOLID)
	gc.set_function(gtk.gdk.COPY)
	self.window.draw_rectangle(self.style.white_gc,True,0,0,480,20)
	if self.kyes != None:
	    for n in xrange(self.kyes):
		self.window.draw_pixbuf(gc,self.__kyeimg,0,0,20*n+2,2,self.__kyeimg.get_width(),self.__kyeimg.get_height())
	if self.diamonds != None:
	    ly = pango.Layout(self.pgctx)
	    ly.set_text("Diamonds left: "+str(self.diamonds))
	    self.window.draw_layout(self.style.black_gc,130,2,ly)
	if self.levelnum != None:
	    ly = pango.Layout(self.pgctx)
	    ly.set_text("Level: "+str(self.levelnum))
	    self.window.draw_layout(self.style.black_gc,65,2,ly)
	if self.hint != None:
	    ly = pango.Layout(self.pgctx)
	    ly.set_text("Hint: "+self.hint)
	    self.window.draw_layout(self.style.black_gc,260,2,ly)

    def update(self,**keywords):
	redraw = False
	for k in keywords.keys():
	    if self.__dict__[k] != keywords[k]:
		self.__dict__[k] = keywords[k]
		redraw = True
	if redraw:
	    self.queue_draw_area(0,0,480,20)
